## snapcraft 2.43.1%2B16.04.1

=== tests/integration/snaps/independent-parts/part2/Makefile ===
all:

install:
	@mkdir -p $(DESTDIR)/bin
	@cp file2 $(DESTDIR)/bin/

=== debian/changelog ===
snapcraft (2.43.1+16.04.1) xenial-security; urgency=medium

  [ Sergio Schvezov ]
  * SECURITY UPDATE: library injection vulnerability on strict mode
    snaps built with snapcraft via misconfigured LD_LIBRARY_PATH
    - project_loader: do not export empty environment
    - meta: do not export empty environment. Warn on empty environment.
    - CVE-2020-27348
    - LP: #1901572

 -- Emilia Torino <emilia.torino@canonical.com>  Tue, 01 Dec 2020 09:14:20 -0300

snapcraft (2.43.1) xenial; urgency=medium

  [ Sergio Schvezov ]
  * lxd: support new style snap injection (#2222)
  * snap: prepare override scripts to allow rebuilding (#2223)
  * lxd: wait for cloud-init (#2227)
  * storeapi: handle releasing to a curly braced branch (#2228)
  * snap: use set-version and set-grade (#2230)
  * lxd: proper filename set when using architectures (#2232)
  * tests: cover manifest generation with review-tools (#2235)
  * reporting: record the released version for errors (#2238)
  * file_utils: find tool when using docker and deb (#2240)
  * elf: better messaging on glibc ABI incompatibilities (#2241)
  * New upstream release (LP: #1789766)

  [ Kyle Fazzari ]
  * spread: stop running catkin tests on 18.10 (#2221)
  * snapcraftctl: run in isolation mode (#2224)
  * templates: reimplement templates as python classes (#2226)
  * templates: rename to extensions (#2233)
  * cli: add list-extensions command (#2237)
  * extensions: fix install path (#2236)

  [ Evan Dandrea]
  * reporting: improve messaging on errors (#2242)

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Thu, 30 Aug 2018 00:08:05 +0000

snapcraft (2.43) xenial; urgency=medium

  [ Sergio Schvezov ]
  * recording: expose the version of snapcraft (#2147)
  * tests: add a fixture for OsRelease to simplify test setup
  * recording: add the os-release ID and VERSION_ID to manifest.yaml
  * nodejs plugin: update to the latest 6.x LTS point release (#2157)
  * snap: use apt from the archive instead of compiling (#2156)
  * build_providers: support for communicating with a qemu VM (#2155)
  * many: refactor snapcraft.yaml loading out of load_config (#2160)
  * tests: update codespell, the scope of checks and ordering of static
           tests (#2162)
  * rust plugin: fix cargo builds and run tests (#2170)
  * build_providers: add ssh key managemet to the qemu build provider (#2168)
  * ci: disable osx tests until a new pyyaml is released
  * build_providers: inject snaps when running from a snap (#2174)
  * code: use black as the standard style (#2180)
  * cli: reserve the --debug option for snapcraft projects (#2185)
  * state: allow parametrization of the global state file (#2186)
  * errors: enable sentry by default (#2187)
  * file_utils: get_tool_path to always return an absolute path (#2193)
  * errors: support keyboard interrupts (#2198)
  * build_providers: add a build image setup facility (#2192)
  * build providers: better injection logic (#2196)
  * Revert "ci: disable osx tests until a new pyyaml is released" (#2213)
  * providers: multipass by default on darwin (#2215)
  * New upstream release (LP: #1787419)

  [ Kyle Fazzari ]
  * lifecycle: automatically stage dependencies (#2144)
  * lifecycle: automatically clean dirty steps (#2145)
  * travis: use LXD from 3.0 track (#2149)
  * project_loader: process parts in consistent order (#2146)
  * project_loader: allow loading null parts (#2153)
  * tests: disable sentry (#2154)
  * lifecycle: don't clean priming area if the snap is being tried (#2143)
  * many: extract lifecycle ordering into own module (#2159)
  * many: automatically redo step for specified part (#2152)
  * tests: add lifecycle ordering tests (#2163)
  * many: automatically detect dependency changes (#2165)
  * project_loader: replace dict keys as well as values (#2166)
  * {catkin,python} plugin: support cleaning (#2171)
  * many: add shellcheck to static tests (#2172)
  * lifecycle: detect local source changes (#2167)
  * lifecycle: pass commands to containerbuild, not steps (#2178)
  * cli: SNAPCRAFT_BUILD_ENVIRONMENT isn't deprecated (#2179)
  * pluginhandler: use uname from the host (#2177)
  * store: properly handle disabled deltas (#2181)
  * tests: create basic integration test spread infrastructure (#2173)
  * tests: add spread suite for autotools plugin (#2182)
  * tests: add spread suite for cmake plugin (#2183)
  * spread: stop testing 17.10 (#2197)
  * tests: add spread suite for copy plugin (#2199)
  * tests: add spread suite for nil plugin (#2201)
  * tests: add spread suite for kbuild plugin (#2203)
  * kbuild plugin: stop modifying kconfigfile (#2204)
  * tests: support running spread suite in autopkgtests (#2188)
  * tests: add spread suite for meson plugin (#2205)
  * tests: add spread suite for godeps plugin (#2200)
  * tests: add spread suite for scons plugin (#2208)
  * tests: add spread suite for catkin plugin (#2206)
  * tests: add spread suite for waf plugin (#2210)
  * cli: add inspect subcommand (#2184)
  * tests: add spread suite for tar-content plugin (#2209)
  * tests: add spread suite for ament plugin (#2211)
  * tests: add spread suite for ruby plugin (#2212)
  * project_loader: add basic template support (#2189)
  * spread tests: vendor gotty
  * spread tests: vendor kbuild-template
  * spread tests: vendor hello
  * sentry: support disabling error reporting (#2214)

  [ Daniel Llewellyn ]
  * jhbuild plugin: allow running as 'root' (#2141)

  [ Emmanuel Leblond ]
  * python plugin: add process-dependency-links to the pull_properties (#2190)
  * ci: improve pr template and tools' ignored files list (#2191)

  [ Celso Providelo ]
  * tests: stricter match when running snapcraft revisions (#2195)

  [ Michael Vogt ]
  * go plugin: do not install go debs if go snap is used (#2194)

  [ Jesse Sung ]
  * kbuild plugin: read configs from source directory instead (#2202)

  [ Paolo Pisati ]
  * kernel plugin: install .config as config-$kernelversion (#2207)



## snapcraft 2.43.1%2B18.04.1

=== main/Makefile ===
obj-y := main.o
obj-y += my_functions.o

=== tests/integration/snaps/dependencies/p3/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

all:
	gcc -o p3 $(CFLAGS) $(LDFLAGS) p3.c -lp1 -lp2

install:
	mkdir -p $(DESTDIR)/bin
	cp -a p3 $(DESTDIR)/bin

=== tests/spread/plugins/ament/snaps/ros2-talker-listener/src/talker_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(talker_cpp)

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(std_msgs REQUIRED)

add_definitions("-std=c++11 -Wall -Wextra")

add_executable(talker src/talker.cpp)
ament_target_dependencies(talker
  "rclcpp"
  "std_msgs")
install(TARGETS talker DESTINATION lib/${PROJECT_NAME})

ament_package()

## snapcraft 2.43.1+16.04.1

=== demos/shared-ros/ros-app/src/CMakeLists.txt ===
# toplevel CMakeLists.txt for a catkin workspace
# catkin/cmake/toplevel.cmake

cmake_minimum_required(VERSION 2.8.3)

# optionally provide a cmake file in the workspace to override arbitrary stuff
include(workspace.cmake OPTIONAL)

set(CATKIN_TOPLEVEL TRUE)

# include catkin directly or via find_package()
if(EXISTS "${CMAKE_SOURCE_DIR}/catkin/cmake/all.cmake" AND EXISTS "${CMAKE_SOURCE_DIR}/catkin/CMakeLists.txt")
  set(catkin_EXTRAS_DIR "${CMAKE_SOURCE_DIR}/catkin/cmake")
  # include all.cmake without add_subdirectory to let it operate in same scope
  include(catkin/cmake/all.cmake NO_POLICY_SCOPE)
  add_subdirectory(catkin)

else()
  # use either CMAKE_PREFIX_PATH explicitly passed to CMake as a command line argument
  # or CMAKE_PREFIX_PATH from the environment
  if(NOT DEFINED CMAKE_PREFIX_PATH)
    if(NOT "$ENV{CMAKE_PREFIX_PATH}" STREQUAL "")
      string(REPLACE ":" ";" CMAKE_PREFIX_PATH $ENV{CMAKE_PREFIX_PATH})
    endif()
  endif()

  # list of catkin workspaces
  set(catkin_search_path "")
  foreach(path ${CMAKE_PREFIX_PATH})
    if(EXISTS "${path}/.CATKIN_WORKSPACE")
      list(FIND catkin_search_path ${path} _index)
      if(_index EQUAL -1)
        list(APPEND catkin_search_path ${path})
      endif()
    endif()
  endforeach()

  # search for catkin in all workspaces
  set(CATKIN_TOPLEVEL_FIND_PACKAGE TRUE)
  find_package(catkin REQUIRED
    NO_POLICY_SCOPE
    PATHS ${catkin_search_path}
    NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
  unset(CATKIN_TOPLEVEL_FIND_PACKAGE)
endif()

catkin_workspace()

=== tests/integration/snaps/assemble/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

all:

install:
	cp -a bin $(DESTDIR)/bin
	cp -a subdir $(DESTDIR)/subdir
	if [ -e copy-meta ]; then \
		cp -arT snappy $(DESTDIR)/meta; \
	fi
	cp -a service-start service-stop binary1 $(DESTDIR)/

=== tests/integration/snaps/stage_env/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(simple-cmake NONE)

IF(NOT DEFINED DEP_DIR)
    message(FATAL_ERROR "DEP_DIR is not defined.")
ENDIF(NOT DEFINED DEP_DIR)

# This is here to test $SNAPCRAFT_STAGE
IF(NOT EXISTS "${DEP_DIR}/s")
    message(FATAL_ERROR "${DEP_DIR}/s does not exist.")
ENDIF(NOT EXISTS "${DEP_DIR}/s")

file(WRITE my-file "stub file")
install(FILES my-file DESTINATION share)

=== tests/spread/plugins/cmake/snaps/cmake-with-lib/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (usefoo)
add_library(foo foo.h foo.cpp)
add_executable(usefoo main.cpp)
target_link_libraries(usefoo foo)
install(TARGETS usefoo
        RUNTIME DESTINATION bin)

=== tests/spread/plugins/catkin/snaps/catkin-shared-ros/producer/src/underlay_package/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(underlay_package)

find_package(catkin REQUIRED)

catkin_package()

=== debian/control ===
Source: snapcraft
Section: utils
Priority: extra
Maintainer: Snapcraft Team <snapcraft@lists.snapcraft.io>
Build-Depends: bash-completion,
               bzr,
               cpio,
               debhelper (>= 9),
               dh-python,
               execstack,
               git,
               mercurial,
               p7zip-full,
               patchelf (>= 0.9),
               pkg-config,
               python3 (>= 3.4),
               python3-apt,
               python3-click,
               python3-debian,
               python3-docopt,
               python3-fixtures,
               python3-jsonschema,
               python3-lxml,
               python3-paramiko,
               python3-petname,
               python3-pkg-resources,
               python3-progressbar,
               python3-pyelftools,
               python3-pymacaroons,
               python3-pyramid,
               python3-pysha3,
               python3-requests,
               python3-requests-toolbelt,
               python3-requests-unixsocket,
               python3-responses,
               python3-simplejson,
               python3-setuptools,
               python3-tabulate,
               python3-testscenarios,
               python3-testtools,
               python3-xdg,
               python3-yaml,
               rpm2cpio,
               subversion,
               squashfs-tools,
               xdelta3,
Homepage: https://github.com/snapcore/snapcraft
Vcs-Git: https://github.com/snapcore/snapcraft.git
Vcs-Browser: https://github.com/snapcore/snapcraft
Standards-Version: 3.9.8

Package: snapcraft
Architecture: all
Depends: binutils,
         execstack,
         patchelf (>= 0.9),
         python3-apt,
         python3-debian,
         python3-click,
         python3-jsonschema,
         python3-lxml,
         python3-paramiko,
         python3-petname,
         python3-pkg-resources,
         python3-progressbar,
         python3-pyelftools,
         python3-pymacaroons,
         python3-pysha3,
         python3-requests,
         python3-requests-toolbelt,
         python3-requests-unixsocket,
         python3-setuptools,
         python3-simplejson,
         python3-tabulate,
         python3-xdg,
         python3-yaml,
         squashfs-tools,
         sudo,
         xdelta3,
         ${misc:Depends},
         ${python3:Depends}
Suggests: lxd, snapd (>= 2.15~)
Description: easily craft snaps
 Snapcraft aims to make upstream developers' lives easier and as such is not
 a single toolset, but instead is a collection of tools that enable the
 natural workflow of an upstream to be extended with a simple release step
 into Snappy.

Package: snapcraft-parser
Architecture: all
Depends: snapcraft (= ${binary:Version}),
         python3-docopt,
         ${misc:Depends},
         ${python3:Depends},
Description: cloud parser for shared snapcraft parts.
 The parser is in charge of getting all the shared parts out there
 indexed into a common cacheable file. It processes multiple origin's
 specified in yaml documents and outputs `parts` which snapcraft can
 utilize.

Package: snapcraft-examples
Architecture: all
Depends: snapcraft (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Description: examples and demos for snapcraft
 Snapcraft aims to make upstream developers' lives easier and as such is not
 a single toolset, but instead is a collection of tools that enable the
 natural workflow of an upstream to be extended with a simple release step
 into Snappy.
 .
 This package contains examples and demos for snapcraft.

=== debian/tests/control ===
Tests: integrationtests-general,
       integrationtests-lifecycle,
       integrationtests-sources,
       integrationtests-store,
       integrationtests-plugins,
       integrationtests-plugins-python,
       integrationtests-plugins-nodejs,
       integrationtests-plugins-java,
       integrationtests-snapd,
       integrationtests-snapd-slow
Restrictions: needs-root, allow-stderr, isolation-container, rw-build-tree
Depends: @,
         bzr,
         curl,
         fuse,
         git,
         lxd,
         mercurial,
         pyflakes,
         python-flake8,
         python3-fixtures,
         python3-pep8,
         python3-pexpect,
         python3-pyftpdlib,
         python3-pyramid,
         python3-testscenarios,
         snapd (>= 2.15~),
         squashfuse,
         subversion

Tests: integrationtests-spread
Restrictions: needs-root, allow-stderr, isolation-machine, rw-build-tree
Depends: @,
         fuse,
         gcc,
         git,
         libc6-dev,
         openssh-server,
         snapd (>= 2.15~),

Tests: snapstests
Restrictions: needs-root, allow-stderr, isolation-container, rw-build-tree
Depends: @,
         git,
         curl,
         fuse,
         python3-fixtures,
         python3-pexpect,
         python3-requests-unixsocket,
         python3-testscenarios,
         snapd (>= 2.15~),
         squashfuse,

## snapcraft 2.43.1+18.04.1

=== Makefile ===
VERSION = 1
PATCHLEVEL = 0
SUBLEVEL = 0
EXTRAVERSION =
NAME = KBuild Template

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# o Do not use make's built-in rules and variables
#   (this increases performance and avoids hard-to-debug behaviour);
# o Look for make include files relative to root of kernel src
MAKEFLAGS += -rR --include-dir=$(CURDIR)

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into myapp), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
  quiet=silent_
endif
else					# make-3.8x
ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
endif
endif

export quiet Q KBUILD_VERBOSE

# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(words $(subst :, ,$(CURDIR))), 1)
  $(error main directory cannot contain spaces nor colons)
endif

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
								&& /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error failed to create output directory "$(saved-output)"))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	@:

sub-make:
	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/sparse.txt" for more details, including
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

PHONY += all
_all: all

ifeq ($(KBUILD_SRC),)
        # building in the source tree
        srctree := .
else
        ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(KBUILD_SRC)
        endif
endif

objtree		:= .
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)

export srctree objtree VPATH

ARCH		?= $(SUBARCH)
CROSS_COMPILE	?= $(CONFIG_CROSS_COMPILE:"%"=%)

KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = gcc
HOSTCXX      = g++
HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer -std=gnu89
HOSTCXXFLAGS = -O2

ifeq ($(shell $(HOSTCC) -v 2>&1 | grep -c "clang version"), 1)
HOSTCFLAGS  += -Wno-unused-value -Wno-unused-parameter \
		-Wno-missing-field-initializers -fno-delete-null-pointer-checks
endif

# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_BUILTIN := 1

export KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC


# We need some generic definitions (do not try to remake the file).
scripts/Kbuild.include: ;
include scripts/Kbuild.include

# Make variables (CC, etc...)
AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
PERL		= perl
PYTHON		= python
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void $(CF)
NOSTDINC_FLAGS  =
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=

# Use MYAPPINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
MYAPPINCLUDE    := \
		$(if $(KBUILD_SRC), -I$(srctree)/include) \
		-Iinclude -include include/generated/autoconf.h

KBUILD_CPPFLAGS := -D__MYAPP__

KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -Werror-implicit-function-declaration \
		   -Wno-format-security \
		   -std=gnu89

KBUILD_AFLAGS_KERNEL :=
KBUILD_CFLAGS_KERNEL :=
KBUILD_AFLAGS   := -D__ASSEMBLY__

KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)

export VERSION PATCHLEVEL SUBLEVEL KERNELVERSION
export ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC
export CPP AR NM STRIP OBJCOPY OBJDUMP
export MAKE AWK PERL PYTHON
export HOSTCXX HOSTCXXFLAGS CHECK CHECKFLAGS

export KBUILD_CPPFLAGS NOSTDINC_FLAGS MYAPPINCLUDE OBJCOPYFLAGS LDFLAGS
export KBUILD_CFLAGS CFLAGS_KERNEL
export KBUILD_AFLAGS AFLAGS_KERNEL
export KBUILD_AFLAGS_KERNEL KBUILD_CFLAGS_KERNEL
export KBUILD_ARFLAGS

# Files to ignore in find ... statements

export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o    \
			  -name CVS -o -name .pc -o -name .hg -o -name .git \) \
			  -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
			 --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:
ifneq ($(KBUILD_SRC),)
	$(Q)ln -fsn $(srctree) source
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile \
	    $(srctree) $(objtree) $(VERSION) $(PATCHLEVEL)
endif

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

version_h := include/generated/version.h

no-dot-config-targets := clean mrproper distclean \
			 cscope help% %docs check% coccicheck \
			 $(version_h) headers_% archheaders archscripts \
			 kernelversion %src-pkg

config-targets := 0
mixed-targets  := 0
dot-config     := 1

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		dot-config := 0
	endif
endif

ifneq ($(filter config %config,$(MAKECMDGOALS)),)
        config-targets := 1
        ifneq ($(words $(MAKECMDGOALS)),1)
                mixed-targets := 1
        endif
endif

# install need also be processed one by one
ifneq ($(filter install,$(MAKECMDGOALS)),)
    mixed-targets := 1
endif

ifeq ($(mixed-targets),1)
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

PHONY += $(MAKECMDGOALS) __build_one_by_one

$(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
	@:

__build_one_by_one:
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done

else
ifeq ($(config-targets),1)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in scripts/kconfig to make the *config target

# Read arch specific Makefile to set KBUILD_DEFCONFIG as needed.
# KBUILD_DEFCONFIG may point out an alternative default configuration
# used for 'make defconfig'
-include arch/$(ARCH)/Makefile
export KBUILD_DEFCONFIG KBUILD_KCONFIG

config: scripts_basic outputmakefile FORCE
	$(Q)$(MAKE) $(build)=scripts/kconfig $@

%config: scripts_basic outputmakefile FORCE
	$(Q)$(MAKE) $(build)=scripts/kconfig $@

else

=== requirements.txt ===
click>=6.2
configparser==3.5.0
docopt==0.6.2
jsonschema==2.5.1
paramiko==2.4.1
progressbar33==2.4
PyYAML==3.11; sys.platform != 'darwin'
PyYAML==3.13; sys.platform == 'darwin'
pyxdg==0.25
requests==2.9.1
requests_unixsocket==0.1.5
https://launchpad.net/ubuntu/+archive/primary/+files/python-apt_1.1.0~beta1build1.tar.xz; sys_platform == 'linux'
https://launchpad.net/python-distutils-extra/trunk/2.39/+download/python-distutils-extra-2.39.tar.gz
requests-toolbelt==0.6.0
responses==0.5.1
petname==1.12
pyelftools==0.24
pymacaroons==0.9.2; sys_platform != 'win32'
pymacaroons==0.10.0; sys_platform == 'win32'
pymacaroons-pynacl==0.9.3
pysha3==1.0b1; python_version < '3.6'
raven==6.5.0
simplejson==3.8.2
tabulate==0.7.5
python-debian==0.1.28
chardet==2.3.0
cx_Freeze>=5.0.2; sys_platform == 'win32'

=== lib/Makefile ===
lib-$(CONFIG_LOG_ENABLE) += logmsg.o

=== scripts/Makefile ===
# Let clean descend into subdirs
subdir-	+= basic kconfig

=== demos/shared-ros/Makefile ===
all: ros-app/*.snap

ros-base/*.snap:
	cd ros-base && snapcraft

ros-app/ros-base.tar.bz2: ros-base/*.snap
	tar czf ros-app/ros-base.tar.bz2 -C ros-base stage/

ros-app/*.snap: ros-app/ros-base.tar.bz2
	cd ros-app && snapcraft

.PHONY: clean
clean:
	cd ros-base && snapcraft clean
	cd ros-app && snapcraft clean
	rm -f ros-app/*.tar.bz2 ros-app/*.snap ros-base/*.snap

=== tools/api/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = snapcraft
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== tests/integration/snaps/classic-build/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-
.PHONY: all

all: hello-classic

install: hello-classic
	install -d $(DESTDIR)/bin
	install $^ $(DESTDIR)/bin/

hello-classic: hello-classic.c

=== tests/integration/snaps/cmake-with-env-var/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(cmake-with-env-var C)
add_definitions(-DPART_SRC=${PART_SRC})
add_definitions(-DPART_BUILD=${PART_BUILD})
add_definitions(-DPART_INSTALL=${PART_INSTALL})
add_executable(cmake-with-env-var test.c)
install(TARGETS cmake-with-env-var RUNTIME DESTINATION bin)

=== tests/integration/snaps/make-with-artifacts/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

all:
	gcc -o test test.c

=== tests/integration/snaps/make-with-filesets/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

all:
	echo "share1" > share1
	echo "share2" > share2
	echo "bin1" > bin1
	echo "bin2" > bin2

install:
	mkdir -p $(DESTDIR)/to-share
	mkdir -p $(DESTDIR)/to-bin1
	mkdir -p $(DESTDIR)/to-bin2
	cp -a share1 $(DESTDIR)/to-share
	cp -a share2 $(DESTDIR)/
	cp -a bin1 $(DESTDIR)/to-bin1
	cp -a bin2 $(DESTDIR)/to-bin2

=== tests/integration/snaps/scriptlet-build/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

build:
	touch build-build
	touch jobs-$(SNAPCRAFT_PARALLEL_BUILD_COUNT)

move-to-dest:
	touch $(DESTDIR)/build-install

=== vendor/github.com/yudai/hcl/Makefile ===
TEST?=./...

default: test

fmt: generate
	go fmt ./...

test: generate
	go test $(TEST) $(TESTARGS)

generate:
	go generate ./...

updatedeps:
	go get -u golang.org/x/tools/cmd/stringer

.PHONY: default generate test updatedeps

=== debian/changelog ===
snapcraft (2.43.1+18.04.1) bionic-security; urgency=medium

  [ Sergio Schvezov ]
  * SECURITY UPDATE: library injection vulnerability on strict mode
    snaps built with snapcraft via misconfigured LD_LIBRARY_PATH
    - project_loader: do not export empty environment
    - meta: do not export empty environment. Warn on empty environment.
    - CVE-2020-27348
    - LP: #1901572

 -- Emilia Torino <emilia.torino@canonical.com>  Tue, 01 Dec 2020 09:10:42 -0300

snapcraft (2.43.1+18.04) bionic; urgency=medium

  [ Sergio Schvezov ]
  * lxd: support new style snap injection (#2222)
  * snap: prepare override scripts to allow rebuilding (#2223)
  * lxd: wait for cloud-init (#2227)
  * storeapi: handle releasing to a curly braced branch (#2228)
  * snap: use set-version and set-grade (#2230)
  * lxd: proper filename set when using architectures (#2232)
  * tests: cover manifest generation with review-tools (#2235)
  * reporting: record the released version for errors (#2238)
  * file_utils: find tool when using docker and deb (#2240)
  * elf: better messaging on glibc ABI incompatibilities (#2241)
  * New upstream release (LP: #1789766)

  [ Kyle Fazzari ]
  * spread: stop running catkin tests on 18.10 (#2221)
  * snapcraftctl: run in isolation mode (#2224)
  * templates: reimplement templates as python classes (#2226)
  * templates: rename to extensions (#2233)
  * cli: add list-extensions command (#2237)
  * extensions: fix install path (#2236)

  [ Evan Dandrea]
  * reporting: improve messaging on errors (#2242)

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Thu, 30 Aug 2018 00:08:05 +0000

## snapcraft 2.43.1+18.10

=== debian/changelog ===
snapcraft (2.43.1+18.10) cosmic; urgency=medium

  [ Sergio Schvezov ]
  * lxd: support new style snap injection (#2222)
  * snap: prepare override scripts to allow rebuilding (#2223)
  * lxd: wait for cloud-init (#2227)
  * storeapi: handle releasing to a curly braced branch (#2228)
  * snap: use set-version and set-grade (#2230)
  * lxd: proper filename set when using architectures (#2232)
  * tests: cover manifest generation with review-tools (#2235)
  * reporting: record the released version for errors (#2238)
  * file_utils: find tool when using docker and deb (#2240)
  * elf: better messaging on glibc ABI incompatibilities (#2241)
  * New upstream release (LP: #1789766)

  [ Kyle Fazzari ]
  * spread: stop running catkin tests on 18.10 (#2221)
  * snapcraftctl: run in isolation mode (#2224)
  * templates: reimplement templates as python classes (#2226)
  * templates: rename to extensions (#2233)
  * cli: add list-extensions command (#2237)
  * extensions: fix install path (#2236)

  [ Evan Dandrea]
  * reporting: improve messaging on errors (#2242)

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Thu, 30 Aug 2018 00:08:05 +0000

## snapcraft 3.0ubuntu1

=== debian/changelog ===
snapcraft (3.0ubuntu1) eoan; urgency=medium

  * autopkgtests: adapt tests to newly introduced limited package

 -- Sergio Schvezov <sergio.schvezov@canonical.com>  Wed, 11 Sep 2019 17:21:39 +0000

snapcraft (3.0) eoan; urgency=medium

  * switch to snap:
    - Empty source package
    - Switch version to 3
    - Set debian/compat to 11
    - Set Standards-Version to 4.2.1
    - Update source Homepage
    - Add dummy snapcraft binaries that re-exec the snap
    - Add transitional packages for snapcraft- binary debs

 -- Sergio Schvezov <sergio.schvezov@canonical.com>  Mon, 9 Sep 2019 09:55:56 +0000

snapcraft (2.44+19.10ubuntu5) eoan; urgency=medium

  * spread: filter cross compilation tests for autotools

 -- Sergio Schvezov <sergio.schvezov@canonical.com>  Thu, 29 Aug 2019 09:55:56 +0000

snapcraft (2.44+19.10ubuntu4) eoan; urgency=medium

  * integration tests: disable review tools checks on s390x

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Wed, 28 Aug 2019 20:15:31 +0000

snapcraft (2.44+19.10ubuntu3) eoan; urgency=medium

  * spread: add provider for adhoc arm64 on Disco and Eoan
  * spread: filter cross compilation tests
  * spread: simpler cleanup for autotools/classic task

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Wed, 28 Aug 2019 03:23:29 +0000

snapcraft (2.44+19.10ubuntu2) eoan; urgency=medium

  [ Sergio Schvezov ]
  * spread: update adhoc provider with newer Ubuntu series
  * python plugin: install python3-distutils when series is != xenial
  * rust plugin: support for s390x
  * integration tests: remove obsolete system library test

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Tue, 27 Aug 2019 09:59:42 +0000

snapcraft (2.44+19.10ubuntu1) eoan; urgency=medium

  * unit tests: update for package set in eoan

 -- Sergio Schvezov <sergio.schvezov@ubuntu.com>  Mon, 26 Aug 2019 01:59:51 +0000

snapcraft (2.44+19.10) eoan; urgency=medium

  [ Sergio Schvezov ]
  * docker: support for testing snapcraft in proposed (#2245)
  * snap: add the https transport (#2244)
  * build providers: environment setup for projects (#2225)
  * build providers: provide support to shell in (#2249)
  * build providers: shell in provider if debug is used (#2252)
  * build-providers: add support for --shell-after  (#2253)
  * build providers: add support for --shell (#2254)
  * build providers: snapcraft images for multipass (#2258)
  * build providers: allow setting ram and disk size (#2260)
  * build providers: inject the base for classic (#2261)
  * build providers: allow snapcraft channel selection (#2265)
  * build providers: refresh packages on bring up (#2267)
  * build providers: let the implementor pick the image (#2269)
  * reporting: fail gracefully on submit errors (#2271)
  * meta: friendlier message for incorrect app command (#2272)
  * snap: use a newer PyYAML and drop patches (#2274)
  * build providers: use the best CPU configuration (#2273)
  * build providers: use the provider if exported (#2275)
  * snap: move to a newer pysha3 (#2277)
  * spread: move legacy wiki tests to spread (#2276)
  * snap: pull early (#2278)
  * build providers: re-exec as root (#2281)
  * build providers: cleaner start and launch messaging (#2282)
  * setup: improve dir setup for when running in legacy mode (#2307)
  * snap: legacy needs to now it is legacy for re-exec (#2311)
  * meta: support relocatable prime for path verification (#2287) (#2312)
  * nodejs plugin: add support for ppc64el and s390x (#2310) (#2310) (#2314)
  * tests: add spread suite for plainbox plugin (#2317) (#2321)
  * project_loader: add git to build-packages for version: git (#2403) (#2406)
  * yaml_utils: allow unicode while encoding (#2414) (#2416)
  * clean: user friendly message when cleaning (#2422)
  * rust plugin: refactor to use the latest rustup
  * tests: remove osx tests for legacy
  * static: fix new shell check issues
  * project loader: remove special LD_LIBRARY_FLAGS handling for classic
  * meta: handle symlinked hooks (#2478) (#2481)
  * common: add is_deb method
  * lifecycle: warn about bases
  * unit tests: stricter testing for common.is_deb
  * common: take into account dpkg not being found
  * common: check if running from snap before deb
  * common: check for relative argv0 in is_deb
  * repo: set priority to critical for debs
  * cli: convert users of click.confirm/prompt to echo.confirm/prompt
  * cli: retrieve error data from provider (#2455)
  * tests: use more fine grained assertions in lifecycle tests (#2637)
  * spread tests: finer grained system selection for unicode test
  * rust plugin: fix linker on i386 (#2580)
  * tests: skip rust unit tests on s390x
  * spread tests: finer grained system support for catkin tests
  * New upstream release (LP: #1837823)

  [ Kyle Fazzari ]
  * yaml loading: properly handle unhashable types (#2247)
  * pluginhandler: stop using alias for snapcraftctl (#2251)
  * local source: don't include .snapcraft directory (#2256)
  * meta: take charge of environment used to run commands (#2257)
  * cli: show trace if no tty (#2259)
  * catkin plugin: use SnapcraftException (#2255)
  * project_loader: add preflight check (#2250)
  * project: catch parent YAML exceptions (#2263)
  * tests: disable integration tests using snaps in bionic container (#2266)
  * catkin, rosdep: stop using FileNotFoundErrors (#2270)
  * sanity checks: allow snap/local dir (#2268)
  * sanity checks: run properly on build VMs (#2279)
  * snapcraft snap: refactor override-build into a script (#2283)
  * packaging: pin click to v6 in requirements.txt (#2299)
  * part grammar processor: lazily capture attributes from plugin (#2297)
  * requirements.txt: stop using pymacaroons-pynacl (#2303)
  * pluginhandler: update build should overwrite organize (#2290) (#2305)
  * ruby plugin: support new download URL (#2467)
  * integration tests: use correct series in get_package_version (#2549)
  * catkin spread test: allow python2 as well as python (#2547)


=== debian/control ===
Source: snapcraft
Section: utils
Priority: extra
Maintainer: Snapcraft Team <snapcraft@lists.snapcraft.io>
Build-Depends: debhelper (>= 11), po-debconf
Homepage: https://snapcraft.io
Vcs-Git: https://github.com/snapcore/snapcraft.git
Vcs-Browser: https://github.com/snapcore/snapcraft
Standards-Version: 4.3.0

Package: snapcraft
Architecture: all
Depends: ${misc:Depends},
Pre-Depends: debconf, snapd
Breaks: snapcraft-parser (<< 3.0~), snapcraft-examples (<< 3.0~)
Replaces: snapcraft-parser (<< 3.0~), snapcraft-examples (<< 3.0~)
Section: oldlibs
Description: Transitional package - snapcraft -> snap (snapcraft)
  This is a transitional dummy package. It can safely be removed.
  .
  snapcraft is now replaced by the Snapcraft snap.

Package: snapcraft-parser
Architecture: all
Depends: snapcraft (>= ${source:Version}), ${misc:Depends},
Section: oldlibs
Description: Transitional package - snapcraft-parser -> snap (snapcraft)
  This is a transitional dummy package. It can safely be removed.
  .
  snapcraft-parser is no longer part of Snapcraft.

Package: snapcraft-examples
Architecture: all
Depends: snapcraft (>= ${source:Version}), ${misc:Depends},
Section: oldlibs
Description: Transitional package - snapcraft-examples -> snap (snapcraft)
  This is a transitional dummy package. It can safely be removed.
  .
  snapcraft-examples is no longer part of Snapcraft.

=== debian/rules ===
#!/usr/bin/make -f
# -*- Mode:Makefile; indent-tabs-mode:t; tab-width:4 -*-

%:
	dh $@

=== debian/tests/control ===
Tests: deb2snap
Restrictions: allow-stderr, isolation-machine
Depends: @,
         grep

## snapcraft 3.0ubuntu1.1

=== debian/changelog ===
snapcraft (3.0ubuntu1.1) focal; urgency=medium

  * autopkgtests: make version check more flexible (LP: #1894849)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 08 Sep 2020 15:46:02 +0200

## snapcraft 3.0ubuntu2

=== debian/changelog ===
snapcraft (3.0ubuntu2) groovy; urgency=medium

  * autopkgtests: make version check more flexible (LP: 1894849)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 08 Sep 2020 15:46:02 +0200
